<?php

namespace Sabre\OTAPing;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'AcceptablePaymentCardsInfoType' => '\\Sabre\\OTAPing\\Structs\\AcceptablePaymentCardsInfoType',
            'AcceptablePaymentCards' => '\\Sabre\\OTAPing\\Structs\\AcceptablePaymentCards',
            'AcceptablePaymentCard' => '\\Sabre\\OTAPing\\Structs\\AcceptablePaymentCard',
            'AcceptedPaymentsType' => '\\Sabre\\OTAPing\\Structs\\AcceptedPaymentsType',
            'AddressInfoType' => '\\Sabre\\OTAPing\\Structs\\AddressInfoType',
            'AddressType' => '\\Sabre\\OTAPing\\Structs\\AddressType',
            'StreetNmbr' => '\\Sabre\\OTAPing\\Structs\\StreetNmbr',
            'BldgRoom' => '\\Sabre\\OTAPing\\Structs\\BldgRoom',
            'BankAcctType' => '\\Sabre\\OTAPing\\Structs\\BankAcctType',
            'BlackoutDateType' => '\\Sabre\\OTAPing\\Structs\\BlackoutDateType',
            'CancelInfoRQType' => '\\Sabre\\OTAPing\\Structs\\CancelInfoRQType',
            'CancelInfoRSType' => '\\Sabre\\OTAPing\\Structs\\CancelInfoRSType',
            'CancelRules' => '\\Sabre\\OTAPing\\Structs\\CancelRules',
            'CancelRuleType' => '\\Sabre\\OTAPing\\Structs\\CancelRuleType',
            'CommentType' => '\\Sabre\\OTAPing\\Structs\\CommentType',
            'Comment' => '\\Sabre\\OTAPing\\Structs\\Comment',
            'CommissionType' => '\\Sabre\\OTAPing\\Structs\\CommissionType',
            'CommissionableAmount' => '\\Sabre\\OTAPing\\Structs\\CommissionableAmount',
            'PrepaidAmount' => '\\Sabre\\OTAPing\\Structs\\PrepaidAmount',
            'FlatCommission' => '\\Sabre\\OTAPing\\Structs\\FlatCommission',
            'CommissionPayableAmount' => '\\Sabre\\OTAPing\\Structs\\CommissionPayableAmount',
            'CompanyNameType' => '\\Sabre\\OTAPing\\Structs\\CompanyNameType',
            'ConnectionType' => '\\Sabre\\OTAPing\\Structs\\ConnectionType',
            'ConnectionLocation' => '\\Sabre\\OTAPing\\Structs\\ConnectionLocation',
            'ContactPersonType' => '\\Sabre\\OTAPing\\Structs\\ContactPersonType',
            'Telephone' => '\\Sabre\\OTAPing\\Structs\\Telephone',
            'CountryNameType' => '\\Sabre\\OTAPing\\Structs\\CountryNameType',
            'CustomerType' => '\\Sabre\\OTAPing\\Structs\\CustomerType',
            'Email' => '\\Sabre\\OTAPing\\Structs\\Email',
            'Address' => '\\Sabre\\OTAPing\\Structs\\Address',
            'URL' => '\\Sabre\\OTAPing\\Structs\\URL',
            'CitizenCountryName' => '\\Sabre\\OTAPing\\Structs\\CitizenCountryName',
            'PhysChallName' => '\\Sabre\\OTAPing\\Structs\\PhysChallName',
            'PaymentForm' => '\\Sabre\\OTAPing\\Structs\\PaymentForm',
            'AssociatedSupplier' => '\\Sabre\\OTAPing\\Structs\\AssociatedSupplier',
            'CustLoyalty' => '\\Sabre\\OTAPing\\Structs\\CustLoyalty',
            'AdditionalLanguage' => '\\Sabre\\OTAPing\\Structs\\AdditionalLanguage',
            'DateTimeSpanType' => '\\Sabre\\OTAPing\\Structs\\DateTimeSpanType',
            'StartDateWindow' => '\\Sabre\\OTAPing\\Structs\\StartDateWindow',
            'EndDateWindow' => '\\Sabre\\OTAPing\\Structs\\EndDateWindow',
            'DirectBillType' => '\\Sabre\\OTAPing\\Structs\\DirectBillType',
            'CompanyName' => '\\Sabre\\OTAPing\\Structs\\CompanyName',
            'DocumentType' => '\\Sabre\\OTAPing\\Structs\\DocumentType',
            'AdditionalPersonNames' => '\\Sabre\\OTAPing\\Structs\\AdditionalPersonNames',
            'EmailType' => '\\Sabre\\OTAPing\\Structs\\EmailType',
            'EmployeeInfoType' => '\\Sabre\\OTAPing\\Structs\\EmployeeInfoType',
            'EquipmentType' => '\\Sabre\\OTAPing\\Structs\\EquipmentType',
            'ErrorType' => '\\Sabre\\OTAPing\\Structs\\ErrorType',
            'ErrorsType' => '\\Sabre\\OTAPing\\Structs\\ErrorsType',
            'FeeType' => '\\Sabre\\OTAPing\\Structs\\FeeType',
            'FeesType' => '\\Sabre\\OTAPing\\Structs\\FeesType',
            'FlightSegmentBaseType' => '\\Sabre\\OTAPing\\Structs\\FlightSegmentBaseType',
            'DepartureAirport' => '\\Sabre\\OTAPing\\Structs\\DepartureAirport',
            'ArrivalAirport' => '\\Sabre\\OTAPing\\Structs\\ArrivalAirport',
            'FormattedTextSubSectionType' => '\\Sabre\\OTAPing\\Structs\\FormattedTextSubSectionType',
            'FormattedTextTextType' => '\\Sabre\\OTAPing\\Structs\\FormattedTextTextType',
            'FormattedTextType' => '\\Sabre\\OTAPing\\Structs\\FormattedTextType',
            'FreeTextType' => '\\Sabre\\OTAPing\\Structs\\FreeTextType',
            'ImageDescriptionType' => '\\Sabre\\OTAPing\\Structs\\ImageDescriptionType',
            'ImageFormat' => '\\Sabre\\OTAPing\\Structs\\ImageFormat',
            'Description' => '\\Sabre\\OTAPing\\Structs\\Description',
            'ImageItemsType' => '\\Sabre\\OTAPing\\Structs\\ImageItemsType',
            'ImageItem' => '\\Sabre\\OTAPing\\Structs\\ImageItem',
            'ImageItemType' => '\\Sabre\\OTAPing\\Structs\\ImageItemType',
            'ItemSearchCriterionType' => '\\Sabre\\OTAPing\\Structs\\ItemSearchCriterionType',
            'Position' => '\\Sabre\\OTAPing\\Structs\\Position',
            'RefPoint' => '\\Sabre\\OTAPing\\Structs\\RefPoint',
            'CodeRef' => '\\Sabre\\OTAPing\\Structs\\CodeRef',
            'HotelRef' => '\\Sabre\\OTAPing\\Structs\\HotelRef',
            'Radius' => '\\Sabre\\OTAPing\\Structs\\Radius',
            'MapArea' => '\\Sabre\\OTAPing\\Structs\\MapArea',
            'LocationGeneralType' => '\\Sabre\\OTAPing\\Structs\\LocationGeneralType',
            'LocationType' => '\\Sabre\\OTAPing\\Structs\\LocationType',
            'MessageAcknowledgementType' => '\\Sabre\\OTAPing\\Structs\\MessageAcknowledgementType',
            'MonetaryRuleType' => '\\Sabre\\OTAPing\\Structs\\MonetaryRuleType',
            'MultimediaDescriptionsType' => '\\Sabre\\OTAPing\\Structs\\MultimediaDescriptionsType',
            'MultimediaDescriptionType' => '\\Sabre\\OTAPing\\Structs\\MultimediaDescriptionType',
            'OperatingAirlineType' => '\\Sabre\\OTAPing\\Structs\\OperatingAirlineType',
            'OperationScheduleType' => '\\Sabre\\OTAPing\\Structs\\OperationScheduleType',
            'OperationTimes' => '\\Sabre\\OTAPing\\Structs\\OperationTimes',
            'OperationTime' => '\\Sabre\\OTAPing\\Structs\\OperationTime',
            'OperationSchedulesType' => '\\Sabre\\OTAPing\\Structs\\OperationSchedulesType',
            'OperationSchedulePlusChargeType' => '\\Sabre\\OTAPing\\Structs\\OperationSchedulePlusChargeType',
            'OperationSchedulesPlusChargeType' => '\\Sabre\\OTAPing\\Structs\\OperationSchedulesPlusChargeType',
            'OperationSchedule' => '\\Sabre\\OTAPing\\Structs\\OperationSchedule',
            'OrdersType' => '\\Sabre\\OTAPing\\Structs\\OrdersType',
            'Order' => '\\Sabre\\OTAPing\\Structs\\Order',
            'Products' => '\\Sabre\\OTAPing\\Structs\\Products',
            'Product' => '\\Sabre\\OTAPing\\Structs\\Product',
            'OriginDestinationInformationType' => '\\Sabre\\OTAPing\\Structs\\OriginDestinationInformationType',
            'OriginLocation' => '\\Sabre\\OTAPing\\Structs\\OriginLocation',
            'DestinationLocation' => '\\Sabre\\OTAPing\\Structs\\DestinationLocation',
            'POS_Type' => '\\Sabre\\OTAPing\\Structs\\POS_Type',
            'ParagraphType' => '\\Sabre\\OTAPing\\Structs\\ParagraphType',
            'ListItem' => '\\Sabre\\OTAPing\\Structs\\ListItem',
            'PaymentCardType' => '\\Sabre\\OTAPing\\Structs\\PaymentCardType',
            'CardIssuerName' => '\\Sabre\\OTAPing\\Structs\\CardIssuerName',
            'SignatureOnFile' => '\\Sabre\\OTAPing\\Structs\\SignatureOnFile',
            'MagneticStripe' => '\\Sabre\\OTAPing\\Structs\\MagneticStripe',
            'PaymentDetailType' => '\\Sabre\\OTAPing\\Structs\\PaymentDetailType',
            'PaymentAmount' => '\\Sabre\\OTAPing\\Structs\\PaymentAmount',
            'PaymentFormType' => '\\Sabre\\OTAPing\\Structs\\PaymentFormType',
            'Voucher' => '\\Sabre\\OTAPing\\Structs\\Voucher',
            'LoyaltyRedemption' => '\\Sabre\\OTAPing\\Structs\\LoyaltyRedemption',
            'LoyaltyCertificate' => '\\Sabre\\OTAPing\\Structs\\LoyaltyCertificate',
            'MiscChargeOrder' => '\\Sabre\\OTAPing\\Structs\\MiscChargeOrder',
            'Ticket' => '\\Sabre\\OTAPing\\Structs\\Ticket',
            'ConjunctionTicketNbr' => '\\Sabre\\OTAPing\\Structs\\ConjunctionTicketNbr',
            'Cash' => '\\Sabre\\OTAPing\\Structs\\Cash',
            'PaymentRulesType' => '\\Sabre\\OTAPing\\Structs\\PaymentRulesType',
            'PersonNameType' => '\\Sabre\\OTAPing\\Structs\\PersonNameType',
            'RateQualifierType' => '\\Sabre\\OTAPing\\Structs\\RateQualifierType',
            'RateComments' => '\\Sabre\\OTAPing\\Structs\\RateComments',
            'RateComment' => '\\Sabre\\OTAPing\\Structs\\RateComment',
            'RecipientInfosType' => '\\Sabre\\OTAPing\\Structs\\RecipientInfosType',
            'RecipientInfo' => '\\Sabre\\OTAPing\\Structs\\RecipientInfo',
            'ShippingInfo' => '\\Sabre\\OTAPing\\Structs\\ShippingInfo',
            'Comments' => '\\Sabre\\OTAPing\\Structs\\Comments',
            'ReferencePlaceHolderType' => '\\Sabre\\OTAPing\\Structs\\ReferencePlaceHolderType',
            'RelatedTravelerType' => '\\Sabre\\OTAPing\\Structs\\RelatedTravelerType',
            'RelativePositionType' => '\\Sabre\\OTAPing\\Structs\\RelativePositionType',
            'RestaurantType' => '\\Sabre\\OTAPing\\Structs\\RestaurantType',
            'MultimediaDescriptions' => '\\Sabre\\OTAPing\\Structs\\MultimediaDescriptions',
            'InfoCodes' => '\\Sabre\\OTAPing\\Structs\\InfoCodes',
            'InfoCode' => '\\Sabre\\OTAPing\\Structs\\InfoCode',
            'CuisineCodes' => '\\Sabre\\OTAPing\\Structs\\CuisineCodes',
            'CuisineCode' => '\\Sabre\\OTAPing\\Structs\\CuisineCode',
            'SourceType' => '\\Sabre\\OTAPing\\Structs\\SourceType',
            'RequestorID' => '\\Sabre\\OTAPing\\Structs\\RequestorID',
            'BookingChannel' => '\\Sabre\\OTAPing\\Structs\\BookingChannel',
            'SpecialRequestType' => '\\Sabre\\OTAPing\\Structs\\SpecialRequestType',
            'SpecialRequest' => '\\Sabre\\OTAPing\\Structs\\SpecialRequest',
            'StateProvType' => '\\Sabre\\OTAPing\\Structs\\StateProvType',
            'StreetNmbrType' => '\\Sabre\\OTAPing\\Structs\\StreetNmbrType',
            'SuccessType' => '\\Sabre\\OTAPing\\Structs\\SuccessType',
            'TPA_ExtensionsType' => '\\Sabre\\OTAPing\\Structs\\TPA_ExtensionsType',
            'TaxType' => '\\Sabre\\OTAPing\\Structs\\TaxType',
            'TaxesType' => '\\Sabre\\OTAPing\\Structs\\TaxesType',
            'TextDescriptionType' => '\\Sabre\\OTAPing\\Structs\\TextDescriptionType',
            'TextItemsType' => '\\Sabre\\OTAPing\\Structs\\TextItemsType',
            'TextItem' => '\\Sabre\\OTAPing\\Structs\\TextItem',
            'TimeDurationType' => '\\Sabre\\OTAPing\\Structs\\TimeDurationType',
            'TimeInstantType' => '\\Sabre\\OTAPing\\Structs\\TimeInstantType',
            'TotalType' => '\\Sabre\\OTAPing\\Structs\\TotalType',
            'TransportationsType' => '\\Sabre\\OTAPing\\Structs\\TransportationsType',
            'TransportationType' => '\\Sabre\\OTAPing\\Structs\\TransportationType',
            'Transportation' => '\\Sabre\\OTAPing\\Structs\\Transportation',
            'TravelDateTimeType' => '\\Sabre\\OTAPing\\Structs\\TravelDateTimeType',
            'TravelerRPHs' => '\\Sabre\\OTAPing\\Structs\\TravelerRPHs',
            'TravelerRPH' => '\\Sabre\\OTAPing\\Structs\\TravelerRPH',
            'URL_Type' => '\\Sabre\\OTAPing\\Structs\\URL_Type',
            'UniqueID_Type' => '\\Sabre\\OTAPing\\Structs\\UniqueID_Type',
            'VendorMessageType' => '\\Sabre\\OTAPing\\Structs\\VendorMessageType',
            'VendorMessagesType' => '\\Sabre\\OTAPing\\Structs\\VendorMessagesType',
            'VerificationType' => '\\Sabre\\OTAPing\\Structs\\VerificationType',
            'PersonName' => '\\Sabre\\OTAPing\\Structs\\PersonName',
            'TelephoneInfo' => '\\Sabre\\OTAPing\\Structs\\TelephoneInfo',
            'ReservationTimeSpan' => '\\Sabre\\OTAPing\\Structs\\ReservationTimeSpan',
            'AssociatedQuantity' => '\\Sabre\\OTAPing\\Structs\\AssociatedQuantity',
            'StartLocation' => '\\Sabre\\OTAPing\\Structs\\StartLocation',
            'EndLocation' => '\\Sabre\\OTAPing\\Structs\\EndLocation',
            'VideoDescriptionType' => '\\Sabre\\OTAPing\\Structs\\VideoDescriptionType',
            'VideoFormat' => '\\Sabre\\OTAPing\\Structs\\VideoFormat',
            'VideoItemsType' => '\\Sabre\\OTAPing\\Structs\\VideoItemsType',
            'VideoItem' => '\\Sabre\\OTAPing\\Structs\\VideoItem',
            'VideoItemType' => '\\Sabre\\OTAPing\\Structs\\VideoItemType',
            'WarningType' => '\\Sabre\\OTAPing\\Structs\\WarningType',
            'WarningsType' => '\\Sabre\\OTAPing\\Structs\\WarningsType',
            'WrittenConfInstType' => '\\Sabre\\OTAPing\\Structs\\WrittenConfInstType',
            'OTA_PingRQ' => '\\Sabre\\OTAPing\\Structs\\OTA_PingRQ',
            'OTA_PingRS' => '\\Sabre\\OTAPing\\Structs\\OTA_PingRS',
            'SignatureType' => '\\Sabre\\OTAPing\\Structs\\SignatureType',
            'SignatureValueType' => '\\Sabre\\OTAPing\\Structs\\SignatureValueType',
            'SignedInfoType' => '\\Sabre\\OTAPing\\Structs\\SignedInfoType',
            'CanonicalizationMethodType' => '\\Sabre\\OTAPing\\Structs\\CanonicalizationMethodType',
            'SignatureMethodType' => '\\Sabre\\OTAPing\\Structs\\SignatureMethodType',
            'ReferenceType' => '\\Sabre\\OTAPing\\Structs\\ReferenceType',
            'TransformsType' => '\\Sabre\\OTAPing\\Structs\\TransformsType',
            'TransformType' => '\\Sabre\\OTAPing\\Structs\\TransformType',
            'DigestMethodType' => '\\Sabre\\OTAPing\\Structs\\DigestMethodType',
            'KeyInfoType' => '\\Sabre\\OTAPing\\Structs\\KeyInfoType',
            'KeyValueType' => '\\Sabre\\OTAPing\\Structs\\KeyValueType',
            'RetrievalMethodType' => '\\Sabre\\OTAPing\\Structs\\RetrievalMethodType',
            'X509DataType' => '\\Sabre\\OTAPing\\Structs\\X509DataType',
            'X509IssuerSerialType' => '\\Sabre\\OTAPing\\Structs\\X509IssuerSerialType',
            'PGPDataType' => '\\Sabre\\OTAPing\\Structs\\PGPDataType',
            'SPKIDataType' => '\\Sabre\\OTAPing\\Structs\\SPKIDataType',
            'ObjectType' => '\\Sabre\\OTAPing\\Structs\\ObjectType',
            'ManifestType' => '\\Sabre\\OTAPing\\Structs\\ManifestType',
            'SignaturePropertiesType' => '\\Sabre\\OTAPing\\Structs\\SignaturePropertiesType',
            'SignaturePropertyType' => '\\Sabre\\OTAPing\\Structs\\SignaturePropertyType',
            'DSAKeyValueType' => '\\Sabre\\OTAPing\\Structs\\DSAKeyValueType',
            'RSAKeyValueType' => '\\Sabre\\OTAPing\\Structs\\RSAKeyValueType',
            'Envelope' => '\\Sabre\\OTAPing\\Structs\\Envelope',
            'Header' => '\\Sabre\\OTAPing\\Structs\\Header',
            'Body' => '\\Sabre\\OTAPing\\Structs\\Body',
            'Fault' => '\\Sabre\\OTAPing\\Structs\\Fault',
            'detail' => '\\Sabre\\OTAPing\\Structs\\Detail',
            'Manifest' => '\\Sabre\\OTAPing\\Structs\\Manifest',
            'Reference' => '\\Sabre\\OTAPing\\Structs\\Reference',
            'Schema' => '\\Sabre\\OTAPing\\Structs\\Schema',
            'MessageHeader' => '\\Sabre\\OTAPing\\Structs\\MessageHeader',
            'Service' => '\\Sabre\\OTAPing\\Structs\\Service',
            'MessageData' => '\\Sabre\\OTAPing\\Structs\\MessageData',
            'SyncReply' => '\\Sabre\\OTAPing\\Structs\\SyncReply',
            'MessageOrder' => '\\Sabre\\OTAPing\\Structs\\MessageOrder',
            'AckRequested' => '\\Sabre\\OTAPing\\Structs\\AckRequested',
            'Acknowledgment' => '\\Sabre\\OTAPing\\Structs\\Acknowledgment',
            'ErrorList' => '\\Sabre\\OTAPing\\Structs\\ErrorList',
            'Error' => '\\Sabre\\OTAPing\\Structs\\Error',
            'StatusResponse' => '\\Sabre\\OTAPing\\Structs\\StatusResponse',
            'StatusRequest' => '\\Sabre\\OTAPing\\Structs\\StatusRequest',
            'sequenceNumber.type' => '\\Sabre\\OTAPing\\Structs\\SequenceNumber_type',
            'PartyId' => '\\Sabre\\OTAPing\\Structs\\PartyId',
            'To' => '\\Sabre\\OTAPing\\Structs\\To',
            'From' => '\\Sabre\\OTAPing\\Structs\\From',
            'Security' => '\\Sabre\\OTAPing\\Structs\\Security',
            'UsernameToken' => '\\Sabre\\OTAPing\\Structs\\UsernameToken',
            'BinarySecurityToken' => '\\Sabre\\OTAPing\\Structs\\BinarySecurityToken',
        );
    }
}
