<?php

namespace Sabre\OTAPing\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Cash Structs
 * Meta informations extracted from the WSDL
 * - documentation: Used to indicate payment in cash.
 * @subpackage Structs
 */
class Cash extends AbstractStructBase
{
    /**
     * The CashIndicator
     * Meta informations extracted from the WSDL
     * - documentation: If true, this indicates cash is being used. | true
     * - use: optional
     * @var bool
     */
    public $CashIndicator;
    /**
     * Constructor method for Cash
     * @uses Cash::setCashIndicator()
     * @param bool $cashIndicator
     */
    public function __construct($cashIndicator = null)
    {
        $this
            ->setCashIndicator($cashIndicator);
    }
    /**
     * Get CashIndicator value
     * @return bool|null
     */
    public function getCashIndicator()
    {
        return $this->CashIndicator;
    }
    /**
     * Set CashIndicator value
     * @param bool $cashIndicator
     * @return \Sabre\OTAPing\Structs\Cash
     */
    public function setCashIndicator($cashIndicator = null)
    {
        $this->CashIndicator = $cashIndicator;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\OTAPing\Structs\Cash
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
