<?php

namespace Sabre\OTAPing\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Comments Structs
 * Meta informations extracted from the WSDL
 * - documentation: A collection of comments.
 * @subpackage Structs
 */
class Comments extends AbstractStructBase
{
    /**
     * The Comment
     * Meta informations extracted from the WSDL
     * - documentation: Comment information pertaining to the purchase. This may be used to pass a message to be printed on a note card.
     * - maxOccurs: 99
     * @var mixed[]
     */
    public $Comment;
    /**
     * Constructor method for Comments
     * @uses Comments::setComment()
     * @param mixed[] $comment
     */
    public function __construct(array $comment = array())
    {
        $this
            ->setComment($comment);
    }
    /**
     * Get Comment value
     * @return mixed[]|null
     */
    public function getComment()
    {
        return $this->Comment;
    }
    /**
     * Set Comment value
     * @throws \InvalidArgumentException
     * @param mixed[] $comment
     * @return \Sabre\OTAPing\Structs\Comments
     */
    public function setComment(array $comment = array())
    {
        $this->Comment = $comment;
        return $this;
    }
    /**
     * Add item to Comment value
     * @throws \InvalidArgumentException
     * @param mixed $item
     * @return \Sabre\OTAPing\Structs\Comments
     */
    public function addToComment($item)
    {
        $this->Comment[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\OTAPing\Structs\Comments
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
