<?php

namespace Sabre\OTAPing\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RecipientInfosType Structs
 * Meta informations extracted from the WSDL
 * - documentation: Information about one or more recipients.
 * @subpackage Structs
 */
class RecipientInfosType extends AbstractStructBase
{
    /**
     * The RecipientInfo
     * Meta informations extracted from the WSDL
     * - maxOccurs: 99
     * @var \Sabre\OTAPing\Structs\RecipientInfo[]
     */
    public $RecipientInfo;
    /**
     * Constructor method for RecipientInfosType
     * @uses RecipientInfosType::setRecipientInfo()
     * @param \Sabre\OTAPing\Structs\RecipientInfo[] $recipientInfo
     */
    public function __construct(array $recipientInfo = array())
    {
        $this
            ->setRecipientInfo($recipientInfo);
    }
    /**
     * Get RecipientInfo value
     * @return \Sabre\OTAPing\Structs\RecipientInfo[]|null
     */
    public function getRecipientInfo()
    {
        return $this->RecipientInfo;
    }
    /**
     * Set RecipientInfo value
     * @throws \InvalidArgumentException
     * @param \Sabre\OTAPing\Structs\RecipientInfo[] $recipientInfo
     * @return \Sabre\OTAPing\Structs\RecipientInfosType
     */
    public function setRecipientInfo(array $recipientInfo = array())
    {
        $this->RecipientInfo = $recipientInfo;
        return $this;
    }
    /**
     * Add item to RecipientInfo value
     * @throws \InvalidArgumentException
     * @param \Sabre\OTAPing\Structs\RecipientInfo $item
     * @return \Sabre\OTAPing\Structs\RecipientInfosType
     */
    public function addToRecipientInfo(\Sabre\OTAPing\Structs\RecipientInfo $item)
    {
        $this->RecipientInfo[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\OTAPing\Structs\RecipientInfosType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
