<?php

namespace Sabre\OTAPing\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Security Structs
 * Meta informations extracted from the WSDL
 * - Prefix: wsse
 * @subpackage Structs
 */
class Security extends AbstractStructBase
{
    /**
     * The UsernameToken
     * Meta informations extracted from the WSDL
     * - Prefix: wsse
     * - minOccurs: 0
     * @var \Sabre\OTAPing\Structs\UsernameToken
     */
    public $UsernameToken;
    /**
     * The SabreAth
     * Meta informations extracted from the WSDL
     * - Prefix: wsse
     * - minOccurs: 0
     * @var string
     */
    public $SabreAth;
    /**
     * The BinarySecurityToken
     * Meta informations extracted from the WSDL
     * - Prefix: wsse
     * - minOccurs: 0
     * @var \Sabre\OTAPing\Structs\BinarySecurityToken
     */
    public $BinarySecurityToken;
    /**
     * Constructor method for Security
     * @uses Security::setUsernameToken()
     * @uses Security::setSabreAth()
     * @uses Security::setBinarySecurityToken()
     * @param \Sabre\OTAPing\Structs\UsernameToken $usernameToken
     * @param string $sabreAth
     * @param \Sabre\OTAPing\Structs\BinarySecurityToken $binarySecurityToken
     */
    public function __construct(\Sabre\OTAPing\Structs\UsernameToken $usernameToken = null, $sabreAth = null, \Sabre\OTAPing\Structs\BinarySecurityToken $binarySecurityToken = null)
    {
        $this
            ->setUsernameToken($usernameToken)
            ->setSabreAth($sabreAth)
            ->setBinarySecurityToken($binarySecurityToken);
    }
    /**
     * Get UsernameToken value
     * @return \Sabre\OTAPing\Structs\UsernameToken|null
     */
    public function getUsernameToken()
    {
        return $this->UsernameToken;
    }
    /**
     * Set UsernameToken value
     * @param \Sabre\OTAPing\Structs\UsernameToken $usernameToken
     * @return \Sabre\OTAPing\Structs\Security
     */
    public function setUsernameToken(\Sabre\OTAPing\Structs\UsernameToken $usernameToken = null)
    {
        $this->UsernameToken = $usernameToken;
        return $this;
    }
    /**
     * Get SabreAth value
     * @return string|null
     */
    public function getSabreAth()
    {
        return $this->SabreAth;
    }
    /**
     * Set SabreAth value
     * @param string $sabreAth
     * @return \Sabre\OTAPing\Structs\Security
     */
    public function setSabreAth($sabreAth = null)
    {
        $this->SabreAth = $sabreAth;
        return $this;
    }
    /**
     * Get BinarySecurityToken value
     * @return \Sabre\OTAPing\Structs\BinarySecurityToken|null
     */
    public function getBinarySecurityToken()
    {
        return $this->BinarySecurityToken;
    }
    /**
     * Set BinarySecurityToken value
     * @param \Sabre\OTAPing\Structs\BinarySecurityToken $binarySecurityToken
     * @return \Sabre\OTAPing\Structs\Security
     */
    public function setBinarySecurityToken(\Sabre\OTAPing\Structs\BinarySecurityToken $binarySecurityToken = null)
    {
        $this->BinarySecurityToken = $binarySecurityToken;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\OTAPing\Structs\Security
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
