<?php

namespace Sabre\OTAPing\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SignatureOnFile Structs
 * Meta informations extracted from the WSDL
 * - documentation: Indicates if the signature is authorized as a form of guarantee. In some countries, the customer can sign the payment card slip as a form of guarantee. | Provides the date range for which the signature is accepted for a guarantee.
 * @subpackage Structs
 */
class SignatureOnFile extends AbstractStructBase
{
    /**
     * The SignatureOnFileIndicator
     * Meta informations extracted from the WSDL
     * - documentation: When true, indicates a signature has been obtained.
     * - use: optional
     * @var bool
     */
    public $SignatureOnFileIndicator;
    /**
     * Constructor method for SignatureOnFile
     * @uses SignatureOnFile::setSignatureOnFileIndicator()
     * @param bool $signatureOnFileIndicator
     */
    public function __construct($signatureOnFileIndicator = null)
    {
        $this
            ->setSignatureOnFileIndicator($signatureOnFileIndicator);
    }
    /**
     * Get SignatureOnFileIndicator value
     * @return bool|null
     */
    public function getSignatureOnFileIndicator()
    {
        return $this->SignatureOnFileIndicator;
    }
    /**
     * Set SignatureOnFileIndicator value
     * @param bool $signatureOnFileIndicator
     * @return \Sabre\OTAPing\Structs\SignatureOnFile
     */
    public function setSignatureOnFileIndicator($signatureOnFileIndicator = null)
    {
        $this->SignatureOnFileIndicator = $signatureOnFileIndicator;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\OTAPing\Structs\SignatureOnFile
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
