<?php

namespace Sabre\OTAPing\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Telephone Structs
 * Meta informations extracted from the WSDL
 * - documentation: Information about a telephone number, including the actual number and its usage. | Information about a contact's telephone number, including the actual number and its usage. | Information on a telephone number for the customer. | The
 * first and last dates between which this telephone number is in effect. | Information about a telephone number, including the actual number and its usage. | Telephone number associated with company to whom remittance is being directed. | Information
 * about a telephone number, including the actual number and its usage. | Telephone number(s) used in the search. | Detailed telephone information for the search. | Card holder's telephone number used for additional authorization checks. | Used to
 * provide phone numbers for a card holder.
 * @subpackage Structs
 */
class Telephone extends AbstractStructBase
{
    /**
     * The TransferAction
     * Meta informations extracted from the WSDL
     * - documentation: Indicates under what conditions the element will be transfered to the booking.
     * - use: optional
     * @var string
     */
    public $TransferAction;
    /**
     * The ParentCompanyRef
     * Meta informations extracted from the WSDL
     * - documentation: A reference to the company from which this element has been inherited.
     * - use: optional
     * @var string
     */
    public $ParentCompanyRef;
    /**
     * Constructor method for Telephone
     * @uses Telephone::setTransferAction()
     * @uses Telephone::setParentCompanyRef()
     * @param string $transferAction
     * @param string $parentCompanyRef
     */
    public function __construct($transferAction = null, $parentCompanyRef = null)
    {
        $this
            ->setTransferAction($transferAction)
            ->setParentCompanyRef($parentCompanyRef);
    }
    /**
     * Get TransferAction value
     * @return string|null
     */
    public function getTransferAction()
    {
        return $this->TransferAction;
    }
    /**
     * Set TransferAction value
     * @param string $transferAction
     * @return \Sabre\OTAPing\Structs\Telephone
     */
    public function setTransferAction($transferAction = null)
    {
        $this->TransferAction = $transferAction;
        return $this;
    }
    /**
     * Get ParentCompanyRef value
     * @return string|null
     */
    public function getParentCompanyRef()
    {
        return $this->ParentCompanyRef;
    }
    /**
     * Set ParentCompanyRef value
     * @param string $parentCompanyRef
     * @return \Sabre\OTAPing\Structs\Telephone
     */
    public function setParentCompanyRef($parentCompanyRef = null)
    {
        $this->ParentCompanyRef = $parentCompanyRef;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\OTAPing\Structs\Telephone
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
