<?php

namespace Sabre\OTAPing\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TextItemsType Structs
 * Meta informations extracted from the WSDL
 * - documentation: Collection of text items.
 * @subpackage Structs
 */
class TextItemsType extends AbstractStructBase
{
    /**
     * The TextItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \Sabre\OTAPing\Structs\TextItem[]
     */
    public $TextItem;
    /**
     * Constructor method for TextItemsType
     * @uses TextItemsType::setTextItem()
     * @param \Sabre\OTAPing\Structs\TextItem[] $textItem
     */
    public function __construct(array $textItem = array())
    {
        $this
            ->setTextItem($textItem);
    }
    /**
     * Get TextItem value
     * @return \Sabre\OTAPing\Structs\TextItem[]|null
     */
    public function getTextItem()
    {
        return $this->TextItem;
    }
    /**
     * Set TextItem value
     * @throws \InvalidArgumentException
     * @param \Sabre\OTAPing\Structs\TextItem[] $textItem
     * @return \Sabre\OTAPing\Structs\TextItemsType
     */
    public function setTextItem(array $textItem = array())
    {
        $this->TextItem = $textItem;
        return $this;
    }
    /**
     * Add item to TextItem value
     * @throws \InvalidArgumentException
     * @param \Sabre\OTAPing\Structs\TextItem $item
     * @return \Sabre\OTAPing\Structs\TextItemsType
     */
    public function addToTextItem(\Sabre\OTAPing\Structs\TextItem $item)
    {
        $this->TextItem[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\OTAPing\Structs\TextItemsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
