<?php

namespace Sabre\OTAPing\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VendorMessagesType Structs
 * Meta informations extracted from the WSDL
 * - documentation: Collection of vendor messages.
 * @subpackage Structs
 */
class VendorMessagesType extends AbstractStructBase
{
    /**
     * The VendorMessage
     * Meta informations extracted from the WSDL
     * - documentation: A specific message associated with this vendor.
     * - maxOccurs: 99
     * @var mixed[]
     */
    public $VendorMessage;
    /**
     * Constructor method for VendorMessagesType
     * @uses VendorMessagesType::setVendorMessage()
     * @param mixed[] $vendorMessage
     */
    public function __construct(array $vendorMessage = array())
    {
        $this
            ->setVendorMessage($vendorMessage);
    }
    /**
     * Get VendorMessage value
     * @return mixed[]|null
     */
    public function getVendorMessage()
    {
        return $this->VendorMessage;
    }
    /**
     * Set VendorMessage value
     * @throws \InvalidArgumentException
     * @param mixed[] $vendorMessage
     * @return \Sabre\OTAPing\Structs\VendorMessagesType
     */
    public function setVendorMessage(array $vendorMessage = array())
    {
        $this->VendorMessage = $vendorMessage;
        return $this;
    }
    /**
     * Add item to VendorMessage value
     * @throws \InvalidArgumentException
     * @param mixed $item
     * @return \Sabre\OTAPing\Structs\VendorMessagesType
     */
    public function addToVendorMessage($item)
    {
        $this->VendorMessage[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\OTAPing\Structs\VendorMessagesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
