<?php

namespace Sabre\OTAPing\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for WarningsType Structs
 * Meta informations extracted from the WSDL
 * - documentation: Collection of warnings.
 * @subpackage Structs
 */
class WarningsType extends AbstractStructBase
{
    /**
     * The Warning
     * Meta informations extracted from the WSDL
     * - documentation: Used in conjunction with the Success element to define a business error.
     * - maxOccurs: 999
     * @var mixed[]
     */
    public $Warning;
    /**
     * Constructor method for WarningsType
     * @uses WarningsType::setWarning()
     * @param mixed[] $warning
     */
    public function __construct(array $warning = array())
    {
        $this
            ->setWarning($warning);
    }
    /**
     * Get Warning value
     * @return mixed[]|null
     */
    public function getWarning()
    {
        return $this->Warning;
    }
    /**
     * Set Warning value
     * @throws \InvalidArgumentException
     * @param mixed[] $warning
     * @return \Sabre\OTAPing\Structs\WarningsType
     */
    public function setWarning(array $warning = array())
    {
        $this->Warning = $warning;
        return $this;
    }
    /**
     * Add item to Warning value
     * @throws \InvalidArgumentException
     * @param mixed $item
     * @return \Sabre\OTAPing\Structs\WarningsType
     */
    public function addToWarning($item)
    {
        $this->Warning[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\OTAPing\Structs\WarningsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
